\ bugwin.f       - isforth debugger windows
\ ------------------------------------------------------------------------

 .( Loading bugwin.f ) cr

\ ------------------------------------------------------------------------

 80 25 screen bug-screen        \ main screen
 35 25 window bug-window        \ decompile display window

 35 24 window info-window       \ menu display
 12 13 window pstk-window       \ stacks display
 12 13 window rstk-window

\ ------------------------------------------------------------------------

: windows
  exec:
    bug-window info-window 
    pstk-window rstk-window ;

\ ------------------------------------------------------------------------
\ table to display function key menu

create f-menu
  2 c,                          \ y coordinate
  ," F1 " ," Step Over    "     \ funtion key and what it does
  ," F2 " ," Step Into"         \ for 2 keys
  3 c, 
  ," F3 " ," Run to Crsr  "
  ," F4 " ," Skip to Crsr"
  4 c, 
  ," F5 " ," Run to exit  "
  ," F6 " ," Skip to exit"
  0 c,

\ ------------------------------------------------------------------------

create menu
  6 c, ," Home  " ," Return Crsr to IP"
  7 c, ," Enter " ," Look into : definition"
  8 c, ," PgDn  " ," Toggle output view"

  10 c, ," B " ," Set Breakpoint at Crsr"
  11 c, ," G " ," Go till key or breakpoint"
  12 c, ," Q " ," Quit back to Forth"
  13 c, ," \ " ," Interpret some Forth"
  0 c,

\ ------------------------------------------------------------------------

: .>bold dup w>bold over count wtype count + ;
: .<bold dup w<bold over count wtype count + ;

\ ------------------------------------------------------------------------

: .f-menu       ( window --- window )
  >r f-menu
  begin
    count ?dup
  while
    1 r@ wat
    r@ .>bold r@ .<bold
    r@ .>bold r@ .<bold
  repeat
  drop r> ;

\ ------------------------------------------------------------------------

: .menu         ( window --- window )
  >r menu
  begin
    count ?dup
  while
    1 r@ wat
    r@ .>bold r@ .<bold 
  repeat
  drop r> ;

\ ------------------------------------------------------------------------

: init-screen
  bug-screen salloc drop
 
  4 0
  do
    bug-screen
    i windows 
    dup walloc drop
    dup blue over w>bg box 
    dup clw attach
  loop

  34  0 rstk-window winpos
  34 12 pstk-window winpos
  45  0 info-window winpos ;

\ ------------------------------------------------------------------------

: draw-menus
  0 7 info-window dup>r wat
  r@ w>bold 
  r@ w" The IsForth Debugger"
  1 7 r@ wat
  r@ w>alt
  green r@ w>fg
  r@ w" pppppppppppppppppppp"
  white r@ w>fg
  r@ w<alt

  r@ .f-menu .menu

  20 1 rot wat
  r> w" Crsr keys move IP location" ;
    
\ ------------------------------------------------------------------------
\ fix box connections in display

create fixup
  34 c,  0 c, 'w' c,            \ x y char...
  45 c,  0 c, 'w' c,
  34 c, 12 c, 't' c,
  45 c, 12 c, 'u' c,
  34 c, 24 c, 'v' c,
  45 c, 23 c, 't' c,

\ ------------------------------------------------------------------------
\ draw main debug window

: draw-screen
  clear
  init-screen draw-menus
  bug-screen .screen 

  white >fg >alt

  fixup 6 
  for
    count swap count rot at
    count >acsc emit
  nxt
  drop
  
  <alt >bold black >bg 
  24 52 at ."  by Mark I Manning IV "
  <bold ;

\ ------------------------------------------------------------------------

0 var see-buffer
0 var see-ptr

\ ------------------------------------------------------------------------

: init-see
  320 allocate drop !> see-buffer ;

\ ------------------------------------------------------------------------

: bug-emit
  dup $0a = 
  if
    see-ptr $fffffff0 and
    32 + !> see-ptr
    drop exit
  then
  see-ptr c!
  incr> see-ptr ;

   
\ ========================================================================
