#! ./isforth -sfload
\ ------------------------------------------------------------------------

\ this file is a cheezy example of how to use isforth to do scripting

\ see args.f and tail.f in the src/ext directory for more details

\ ------------------------------------------------------------------------

: .useage
  cr cr
  5 spaces ." useage:" cr
  10 spaces ." cat.f somefile" cr
  cr
  5 spaces ." writes entire file to console " cr
  5 spaces ." similar to unix cat but cheezier :)" ;

\ ------------------------------------------------------------------------
\ are there any args left on the command line?

\ isforths default arg handling has already parsed the above -fload
\ out of the arg list.  any args left unprocessed now belong to this
\ script - all args are files to be cat'd

0 var f     \ flag - true if we have done at least one file

: more?         ( --- no return | )
  arg# argc =
  if
    f 0=
    if
      .useage
    then
    r> drop 
  then ;

\ ------------------------------------------------------------------------

: open-file
  0 arg@ <open>             \ open specified file for read access only

  dup -1 =                  \ open failed ?
  if
    cr ." Missing File" cr
    0 <exit>
  then 
  on> f ;

\ ------------------------------------------------------------------------
\ write all chars of file to stdout

: (cat)     ( fd --- fd )
  begin
    dup fread1              \ retain fd, read one char from file
    0>                      \ while no error or eof
  while
    emit                    \ display the char
  repeat ;

\ ------------------------------------------------------------------------

: cat
  begin
    more?                   \ did user give a file to be displayed?
    open-file               \ open it or exit script
    (cat)                   \ cat it
    fclose                  \ close it
  again ;

\ ------------------------------------------------------------------------

 cat cr

\ ========================================================================
