\ window.f     - isforth tui dummy screen and window for debug/example
\ ------------------------------------------------------------------------

 vocabulary example example definitions

\ ------------------------------------------------------------------------
\ create some bs windows and a screen

 cols rows screen ascreen       

 cols rows 1- window awindow    
 36 18 window winfoo            
 29 30 window winblah           

\ ------------------------------------------------------------------------
\ current demo character colour

 $07 const color1  \ white on black
 $26 const color2  \ cyan on green
 $47 const color3  \ white on blue

\ ------------------------------------------------------------------------
\ write dummy data into each window, set their locations on the screen

: w-init
  ascreen salloc drop       \ allocate windows and screen
  awindow walloc drop
  winfoo walloc drop
  winblah walloc drop

  ascreen 
    dup awindow attach      \ attach windows to screen
     dup winfoo attach 
        winblah attach 

  awindow                   \ fill each window with bs stuff
    color1 over w.colors c! 
    dup backfill dup box
    color2 over w.colors c!

    0 0 pluck wat
    dup w" These are just a few of the things you can do with the "
    dup w>bold dup w>ul dup w" IsForth"
    dup w<bold dup w<ul w"  Text User Interface code!          "

   winfoo
     color3 over w.colors c!
     dup clw
     dup w>bold dup box dup w<bold
     52 10 rot winpos

   winblah 
     dup clw dup box
     2 3 pluck winpos
     1 dup pluck wat
     w" Hit any key to stop" ;

\ ------------------------------------------------------------------------

3 var c1                    \ counter to string display in scroll window
white var c2                \ color of string display

\ ------------------------------------------------------------------------
\ bump colour up one

\ uncomment the calls to this word below to see just how slow it is to 
\ keep changing attributes all the time

: c2++
  c2
  begin
    1+ 7 and
    blue over <>
  until
  !> c2 ;  

\ ------------------------------------------------------------------------

: down-scroll
  winfoo scroll-dn 
  c1 0= 
  if
    4 !> c1
    0 3 winfoo wat
    c2 winfoo w>fg
    winfoo w" I can scroll windows up too!"
\    c2++                   \ uncomment this to watch it go really slow :/
  then 
  decr> c1 ;

\ ------------------------------------------------------------------------

: up-scroll
  winfoo scroll-up
  c1 4 =
  if
    off> c1
    15 2 winfoo wat
    c2 winfoo w>fg
    winfoo w" I can scroll windows down too!"
\    c2++                   \ this too 
  then
  incr> c1 ;

\ ------------------------------------------------------------------------

 defer doscroll 

\ ------------------------------------------------------------------------

: movewin    ( n1 n2 --- )
  begin
    doscroll
    2dup winblah w.xco
    tuck w+! w@
    <> key? not and
  while
    ascreen .screen
  repeat
  2drop ;

\ ------------------------------------------------------------------------

: moveright  ['] down-scroll is doscroll 69 1 movewin ;
: moveleft   ['] up-scroll is doscroll 2 -1 movewin ;

\ ------------------------------------------------------------------------
\ detach and re-attach winfoo

: foo-detach
  winfoo detach             \ pops window to front
  ascreen winfoo attach ;

\ ------------------------------------------------------------------------

: blah-detach
  winblah detach 
  ascreen winblah attach ;

\ ------------------------------------------------------------------------
\ draw screen, move things around, draw again etc

: wintest
  enacs
  clear curoff w-init 
  begin
    foo-detach moveright 
    blah-detach moveleft  
    key?
  until

  key? if key drop then

  awindow close-win         \ this automatically detaches the window
  winfoo close-win          \ from its parent screen
  winblah close-win

  ascreen close-screen
  
  curon >norm black >bg 
  white >fg clear 
  rows 0 at ;

\ ------------------------------------------------------------------------

 wintest

\ ========================================================================
