\ bload.f       - isforth block file interpret wordset
\ ------------------------------------------------------------------------

 .( loading bload.f ) cr

\ ------------------------------------------------------------------------

 block definitions

\ ------------------------------------------------------------------------

\ i think it would be quite possible to fload a flat file which could
\ open a block file and load from it.  once the requested blocks were
\ loaded we would continue interpreting from the flat file where we 
\ left off.  we could then close said block file.
\
\ dont try having one block file include another though nor try fload
\ a flat file from within a block file!  some things just arent meant
\ to happen!

\ ------------------------------------------------------------------------
\ get address of block to interpret and the number of chars therein

: bsource       ( --- a1 n2 )
  blk bfh >block            \ get address of specified block
  bfh blksize@ * ;          \ get char size of one block

\ ------------------------------------------------------------------------
\ interpret block n1 of default block file ( handle in bfh )

: load          ( n1 --- )
  blk 0=                    \ are we interpreting the first block ?
  if
    ['] bsource is source   \ yes - redefine input source
  then

  >in @ #tib @              \ save interpret position in current block
  tib blk                   \ (or file or terminal ?)
  2>r 2>r                   \ keep parameter stack clean

  bfh blksize@ * #tib !     \ prevent refill (that would be bad)
  !> blk >in off interpret  \ interpret this block
 
  2r> 2r>
  !> blk 'tib !             \ restore 
  #tib ! >in ! 
 
  blk 0=
  if
    ['] (source) is source
  then ;

\ ------------------------------------------------------------------------
\ load all blocks from n1 to n2 inclusive

: thru      ( n1 n2 --- )
  cr 1+ swap 
  do
    i load
  loop ;

\ ------------------------------------------------------------------------
\ load n1 thru n2 blocks following current block

: +thru     ( n1 n2 --- )
  blk dup d+ thru ;

\ ------------------------------------------------------------------------
\ stop loading current block, load next one

: -->
  >in off                   \ skip to start of following block
  incr> blk
  bfh blksize@ * 
  +!> 'tib ;

\ ------------------------------------------------------------------------
\ open specified block file and start loading from specified block

\ e.g.  
\   to load block 10 of foo.blk
\   10 bload foo.blk 

: bload     ( block# --- )
  bl word hhere bopen       \ parse filename and open it
  !> bfh load               \ set default block file handle and load block
  bfh bclose off> bfh ;     \ close specified block file

\ ------------------------------------------------------------------------
\ list specified block of specified file

: list          ( block handle --- )
  cr
  tuck >block               \ get block addr and handle structure addr
  swap blksize@             \ get width and height
  for                       \ ( width address -- )
    2dup type cr
    tuck + swap
  nxt 
  2drop ;    

\ ------------------------------------------------------------------------

 forth definitions

\ ========================================================================
