\ error.f   - isforth error handler creation
\ ------------------------------------------------------------------------

 .( loading error.f ) cr

\ ------------------------------------------------------------------------

\ the word names in here REALY need to be rethunked, i threw this
\ together at about 1 am lst nite

\ ------------------------------------------------------------------------

<headers

 0 var errors               \ array of known error numbers
 0 var vectors              \ array of error handlers for each error #
 0 var #e                   \ number of errors defined

\ ------------------------------------------------------------------------

: (notify)    ( n1 vector --- old-vector )
  swap #e
  if
    errors #e pluck dscan   \ search for n1 in error number list
    nip ?dup 0=             \ discard address - was it found ?
    if                      \ if not get next free location - increment 
      #e incr> #e           \ count
    else                    \ if so FIX the value returned by scan
      #e swap -             \ index to located item in list
    then

( vector n1 index --- )

    4*                      \ convert index to an offset 
    tuck errors + !         \ store error number in list
    vectors +               \ get address of this errors handler vector
    dup @ >r ! r>           \ fetch old vector - store new vector
  else
    errors !                \ list is empty - store first error 
    vectors !               \ number and handler vector
    incr> #e                \ count entries
    0                       \ there was no old handler for this error
  then ;      

\ ------------------------------------------------------------------------
\ create (or steal) handler for a given error 

headers>

: notify:       ( n1 --- )
  : here body>              \ create handler word - get its cfa
  (notify) drop ;           \ add this handler to list. discard old vector

\ ------------------------------------------------------------------------
\ create a handler that "also" gets notified for a given error

: +notify:
  : here body>              \ create handler word - get its cfa
  (notify) ?dup             \ and handler to list. 
  if                        \ did this error have a previous handler?
    >body                   \ yes - get the old handlers body address
    [compile] literal       \ compile as literal within new handler 
    compile >r              \ make new handler exit to old one 
  then ;

\ ------------------------------------------------------------------------

: >error        ( n1 --- )
  errors #e rot dscan nip ?dup  
  if
    #e swap -
    4* vectors +
    @ execute               \ may or may not return
  else
    \ ??? unknown error
  then ;    

\ ------------------------------------------------------------------------

<headers

: init-e
  defers default
  400 dup 
  allocate drop !> errors
  allocate drop !> vectors ;

\ ------------------------------------------------------------------------

  behead
        
\ ------------------------------------------------------------------------
\ examples

\s

1 notify: e1 true abort" Error 1" ;
2 notify: e2 true abort" Error 2" ;
2 +notify: e2+ ." Error 2+ " ;
3 notify: e3 true abort" Error 3" ;
4 notify: w1 ." Warning 1" ;

\ ========================================================================
