\ fsave.f       - isforth saves out executable
\ ------------------------------------------------------------------------

.( loading fsave.f ) cr

\ ------------------------------------------------------------------------

 compiler definitions

\ ------------------------------------------------------------------------

 $10000000 const load-addr

\ this was a bitch - if you modify anything here and it breaks
\ you own both pieces (i stole that :)

\ ------------------------------------------------------------------------
\ find out where the programs entry point is by looking in program header

 load-addr $18 + @ var e_entry   \ man is forth cool or what!

\ ------------------------------------------------------------------------
\ elf file header used by fsave and turnkey

<headers

create elf_header
 $7f c, $45 c, $4c c, $46 c, $01 c, $02 c, $01 c, $00 c,
 $00 c, $00 c, $00 c, $00 c, $00 c, $00 c, $00 c, $00 c,

      $02 w,              \ e_type            executable
      $14 w,              \ e_machine         PPC
        1  ,              \ e_version  
  e_entry  ,              \ e_entry           
      $34  ,              \ e_phoff           offset to program hdr
here  $00  ,              \ e_shoff           section header offset
      $00  ,              \ e_flags
      $34 w,              \ e_ehsize
      $20 w,              \ e_phentsize
      $01 w,              \ e_phnum
      $28 w,              \ e_shentsize       size of a section hdr!
      $03 w,              \ e_shnum           # section hdr entries
      $02 w,              \ e_shstrndx        

\ program header starts here

        1  ,              \ p_type
        0  ,              \ p_offset
 load-addr ,              \ p_vaddr
 load-addr ,              \ p_paddr
here   -1  ,              \ p_filesz
       -1  ,              \ p_memsz
        7  ,              \ p_flags 
    $1000  ,              \ p_align

constant p_filesz
constant e_shoff

\ ------------------------------------------------------------------------
\ string section

create string_table
  0 c,                      \ because some idiots dont understand 0 based
  ,' .text' 0 c,            \ or they assume we dont
  ,' .shstrtab' 0 c,
  align

\ ------------------------------------------------------------------------
\ text section header table entry

create text_header
          1 ,               \ sh_name   offset in $ table to name
          1 ,               \ sh_type   progbits
          7 ,               \ sh_flags  read write executable (dejavu)
    e_entry ,               \ sh_addr   where this section lives
        $80 ,               \ sh_offset file offset to start of section
here      0 ,               \ sh_size   how big is the section (dejavu)
          0 ,               \ sh_link
          0 ,               \ sh_info
        $10 ,               \ sh_addralign
          0 ,               \ sh_entsize          

constant sh_size            \ point to above entry

\ ------------------------------------------------------------------------
\ string table section header entry

create st_hdr
          7 ,               \ sh_name   offset in $ table to name
          3 ,               \ sh_type   sht_strtab
          0 ,               \ sh_flags
          0 ,               \ sh_addr
here      0 ,               \ sh_offset
         15 ,               \ sh_size
          0 ,               \ sh_link
          0 ,               \ sh_info
          1 ,               \ sh_addralign
          0 ,               \ sh_entsize

constant st_off             \ ofset from start of file to string table 

\ ------------------------------------------------------------------------
\ save out extended kernel - headers may or may not have been stripped

: (fsave)
  ['] query is refill       \ fsaving or turnkeying from an fload leaves
  floads off                \ these in a wrong state for the target

  here load-addr -          \ calculate length of memory
  p_filesz 2dup ! 4+ !      \ set memory size and file size in elf header 

\ compile string table onto end of .text

  string_table              \ source
  here dup                  \ destination
  load-addr -               \ calculate file offset to string table
  st_off !                  \ store offset in string table section hdr
  20 dup allot cmove        \ allocate and move 

\ compile section headers

  here dup 
  load-addr - e_shoff !     \ put offset to section headers in elf header
  40 dup allot erase        \ another case of 0 based brain dead people

\ compile .text section header

  p_filesz @ sh_size !      \ set size of .text section in header
  text_header here 
  40 dup allot cmove
 
\ compile the section header for the string tables

  st_hdr here 
  40 dup allot cmove 

  elf_header load-addr 
  80 cmove

  \777                      \ rwxrwxrwx
  \1101                     \ O_TRUNC O_CREAT O_WRONLY

  bl word                   \ parse filename from input
  hhere count s>z           \ convert name to ascii z
  <open3>                   \ create new file

  dup                       \ created? 
  -1 <>
  if
    >in off #tib off        \ so targets tib is empty on entry
    >r                      \ save fd a sec...
    load-addr               \ calculate write length
    here over - swap
    r@ <write>              \ write file
    r> <close>              \ close file
    bye
  then 
  cr $22 emit 

  hhere count type $22 emit
  ."  create error"  cr     \ oopts!
  ." Errno: " errno 
  begin
    10 /% 48 + emit
    10 * ?dup 0=
  until 
  bye ;

\ ------------------------------------------------------------------------
\ pack all headers to 'here' and save out executable

headers>
 
: fsave
  here !> endp              \ tell target where relocated headers are
  pack (fsave) ;            \ pack headers onto end of list space
 
\ ------------------------------------------------------------------------
\ same as fsave but does not pack headers onto end of list space

: turnkey
  here !> endp              \ tell target where end of list is
  on> turnkeyd              \ target doesn't try to relocate non existant
  (fsave) ;                 \ headers when it loads in !!!

\ ------------------------------------------------------------------------

 behead forth definitions 

\ ========================================================================
