\ header.f      - isforth headerless word creation
\ ------------------------------------------------------------------------

 .( loading header.f ) cr

\ ------------------------------------------------------------------------

 compiler definitions

\ ------------------------------------------------------------------------

 vocabulary h-voc h-voc     \ create and put in context

\ ------------------------------------------------------------------------
\ make current headerless state headerless!

hp @                        \ remember true header memory address
current @                   \ remember current vocabulary
definitions                 \ put h-voc in current
over 8192 + hp !            \ headerless headers temp compile address

\ you can create 8KB worth of headered words when creating
\ headerless words but you should behead before that limit is reached

\ -- we are now compiling headerless

   var h-current            \ real current vocabulary (value is on stack)
   var h-hp                 \ hp true address           "      "      "
 2 var h-state              \ current headerless state

\ 0 = no headerless words defined
\ 1 = headerless words created, headers are on
\ 2 = headerless words created, headers are off

\ ------------------------------------------------------------------------
\ zero out all threads of headerless vocabulary

: z-head
  [ ' h-voc >body ] literal
  256 erase ;

\ ------------------------------------------------------------------------

 0 var h?                   \ true if beheading disabled

\ ------------------------------------------------------------------------
\ state is not headerless but has been before. go headerless again

: h1        ( --- )
  current @ !> h-current    \ remember true current
  h-hp                      \ address where headerless headers end
  hp @ !> h-hp              \ remember where true hp left off
  hp !                      \ append headers to headerless headers buffer
  2 !> h-state              \ all words are created headerless
  h-voc definitions ;       \ adds h-voc to context and current

\ ------------------------------------------------------------------------
\ going headerless for first time

: h0
  hp @ 8192 + !> h-hp       \ point hp 8k beyond where it really is
  z-head h1 ;               \ erase h-voc threads and go headerless
  
\ ------------------------------------------------------------------------
\ turn headers off

: <headers
  h? ?exit                  \ don't go headerless if beheading disabled
  h-state
  exec: 
    h0 h1 noop ;

\ ------------------------------------------------------------------------
\ turn headers back on

: headers>      ( --- )
  h? ?exit                  \ don't go headerfull if beheading disabled
  h-state 1 = ?exit         \ we're already back in headerfull mode
  h-state 0= abort" Not in headerless mode"

  decr> h-state             \ headers are on again now
  hp @                      \ where headerless headers left off..
  h-hp hp !                 \ headers compiling into normal head space
  !> h-hp
  h-current current ! ;     \ but h-voc is still in context

\ ------------------------------------------------------------------------
\ zero pointers to nfa at cfa -4 for all words in a thread

: (nonames)     ( thread --- )
  ?dup 0= ?exit             \ empty thread?
  begin                     \ for each header in thread do
    dup name>               \ get cfa
    4- off                  \ erase nfa pointer at cfa -4
    4- @                    \ point to nfa of previous word in thread
    ?dup 0=                 \ reached end of chain ?
  until ;
  
\ ------------------------------------------------------------------------
\ zero pointers to nfa at cfa -4 for all words in the h-voc vocabulary

: nonames
  [ ' h-voc >body ] literal \ point at body of h-voc
  #threads 4* bounds        \ for each thread of hvoc do
  do
    i @ (nonames)           \ remove links to nfa from cfa-4 
  4 +loop ;

\ ------------------------------------------------------------------------
\ these definitions will be beheaded - prevent this

headers>                    \ turn headers back on

' <headers alias <headers   \ both of these words can be thought of as
' headers> alias headers>   \ pointing towards where headered words are

\ ------------------------------------------------------------------------
\ erase all headers - gone forever

: behead
  headers>                  \ turn headers on again
  h-voc previous            \ remove from context
  off> h-state              \ no longer headerless
  nonames                   \ make all beheaded words noname
  z-head ;                  \ erase all threads in h-voc

\ ------------------------------------------------------------------------
\ enable or disable going headerless only if we hare in h-state 0

: +headers h-state ?exit off> h? ;
: -headers h-state ?exit on> h? ;

\ ------------------------------------------------------------------------

 behead forth definitions

\ ========================================================================
