\ list.f        - isforth linked list words
\ ------------------------------------------------------------------------

.( loading list.f ) cr

\ ------------------------------------------------------------------------

 forth definitions

\ ------------------------------------------------------------------------
\ linked list structure

struct: l-list
  1 dfield l.prev
  1 dfield l.next
;struct

\ ------------------------------------------------------------------------
\ useful featureitis overkill

: !next     ( a1 a2 --- ) l.next ! ;
: !prev     ( a1 a2 --- ) l.prev ! ;
: @next     ( a1 --- a2 ) l.next @ ;
: @prev     ( a1 --- a2 ) l.prev @ ;
: 0next     ( a1 --- ) l.next off ;
: 0prev     ( a1 --- ) l.prev off ;
: 0links    ( a1 --- ) dup 0next 0prev ;

\ ------------------------------------------------------------------------
\ add item a2 to top of linked list a1

: list-add        ( a1 a2 --- )
  2dup !next                \ make a1 next after a2
  swap !prev ;              \ mape a2 previous to a1
 
\ ------------------------------------------------------------------------
\ remove item a1 from middle of linked list. 

\ a1 is not first item in list but may be last

: list-delete       ( a1 --- )
  dup
  dup @next                 \ get address of item following a1 (if any)
  swap @prev                \ get address of item before a1 

  2dup !next                \ put a1.next into [a1.prev].next
  swap dup                  \ is there an a1.next?
  ?:
    !prev                   \ yes put a1.prev into [a1.next].prev
    2drop                   \ no discard junk
  0links ;                  \ blank links on deleted item

\ ------------------------------------------------------------------------
\ given pointer to the head of a list (a1) detatch and return first item

: >list@            ( a1 --- a2 )
  dup @ dup                 \ get address of first item in the list
  @next dup                 \ get address of second item 
  if                        \ is tgere a second item?
    dup 0prev               \ erase its link to the first
  then
  rot !                     \ store addr of second item in list head ptr
  dup 0links ;              \ retern a2 - not linked to naything now

\ ========================================================================
