\ meminfo.f     - display information about allocated buffers
\ ------------------------------------------------------------------------

 .( loading meminfo.f ) cr

\ ------------------------------------------------------------------------

<headers

\ ------------------------------------------------------------------------
\ find largest mem block in a list

: (?largest)        ( list --- size )
  0 swap                    \ largest so far...
  begin
    ?dup                    \ any items left in this list ?
  while
    tuck                    \ dont lose position in list
    b.size @                \ get size of this item
    umax                    \ get max so far
    swap @next              \ link to next item in list
  repeat ;
  
\ ------------------------------------------------------------------------
\ find largest block in a given heap

: ?largest        ( heap --- )
  h.free @ 32 +
  9
  for
    dup @ (?largest) ?dup
    if
      r>drop
      nip exit
    then
    4-    
  nxt
  drop 0 ;

\ ------------------------------------------------------------------------

headers>

: .free     ( --- n1 )
  heap0 dup 0=
  if
    10 u.r exit
  then

  begin
    dup ?largest 10 u.r 
    @next ?dup 0=
  until ;

\ ------------------------------------------------------------------------
\ memory debug info display

<headers

0 var h

: | ." | " ;

: bar 
  ." +------+----------+----------+----------+--------+--------+--------+--------+" cr ;

\ ------------------------------------------------------------------------

0 var total
0 var buffs

\ ------------------------------------------------------------------------

: (?total)
  begin
    ?dup
  while
    incr> buffs
    dup b.size @ +!> total
    @next 
  repeat ;

\ ------------------------------------------------------------------------
\ total up all mem-blks in a mem-map

: ?total        ( mem-map --- total )
  off> total
  off> buffs
  9 0
  do    
    dup i 4* + @
    (?total)
  loop
  drop total ;

\ ------------------------------------------------------------------------

: .n .r space | ;

\ ------------------------------------------------------------------------

headers>

: .mem-info    ( --- n1 )
  cr bar
  ." | heap | Largest  | total    | total    | free   | allocd | unused | total  |" cr
  ." | num  | buffer   | free     | used     | blocks | blocks | blocks | blocks |" cr

  bar

  heap0 1 !> h

  begin
    dup>r
    | h 4 .n
    ?largest 8 .n

    r@ h.free @ ?total 8 .n buffs swap 
    r@ h.used @ ?total 8 .n buffs rot
    6 .n 6 .n
    off> buffs r@ h.unused @ 
    (?total) buffs 6 .n
    r@ h.blocks @ @ 6 .n
    cr incr> h
    r> @next ?dup 0=
  until
  bar
  decimal ;

\ ------------------------------------------------------------------------

 behead

\ ========================================================================
