\ timer.f       - isforth elapsed time measurement and delay words
\ ------------------------------------------------------------------------

.( loading timer.f ) cr

\ ------------------------------------------------------------------------

create stime  0 , 0 ,       \ start time
create tv     0 , 0 ,       \ long tv_sec long tv_usec

<headers

create tz     0 , 0 ,       \ tz_minutswest tz_dsttime 
create sec    0 , 0 ,       \ seconds and ms delay time

\ ------------------------------------------------------------------------
\ syscall <gettimeofday> takes 2 parmeters

headers>

 2 78 syscall <gettimeofday> \ tz tv <gettimeofday>

\ ------------------------------------------------------------------------
\ get current number of seconds since epoch in time val struc above

: time@         ( --- seconds-since-epoc )
  tz tv                     \ syscall takes 2 parameters
  <gettimeofday>            \ time val and time zone structure addresses
  drop                      \ bleh - it worked!
  tv @ ;                    \ get returned value

\ ------------------------------------------------------------------------
\ set start time of operation to be timed to current time

: timer-reset 
  time@ !> stime
  [ tv 4+ ] literal @
  [ stime 4+ ] literal ! ;

\ ------------------------------------------------------------------------
\ factored out just to confuse you :)

<headers

: 60m 60 /% swap 0 # # ;        \ extract min or sec

\ ------------------------------------------------------------------------

: (t) 
  60m ':' hold 
  2drop ;

\ ------------------------------------------------------------------------
\ display ammount of time elapsed since timer-reset

headers>

: .elapsed
  base @ decimal

  time@ stime @ -
  [ tv    4+ ] literal @
  [ stime 4+ ] literal @ - 
 
  <#
  0 # # # 2drop '.' hold    \ convert milliseconds
  (t) (t)                   \ convert seconds and minutes
  60m #> type drop          \ convert hours and display it.
  base ! ;

\ ------------------------------------------------------------------------
\ allocate nanosleep syscall

 2 162 syscall <nanosleep> 

\ ------------------------------------------------------------------------

<headers

: (nano)
  begin
    sec sec <nanosleep> 0= 
  until ;

headers>

\ ------------------------------------------------------------------------
\ delay n1 seconds 

: seconds           ( n1 --- )
  sec !
  [ sec 4+ ] literal off
  goto (nano) ;

\ ------------------------------------------------------------------------
\ delay n1 microseconds

: ms                ( n1 --- )
  1000 /% sec !
  1000000 * [ sec 4+ ] literal !
  (nano) ;

\ ------------------------------------------------------------------------

\ do not behead - next file beheads (time.f)

\ ========================================================================
