\ mmtest.f     - isforth memory manager smoke test
\ ------------------------------------------------------------------------

 vocabulary mm mm definitions

\ ------------------------------------------------------------------------

\ this code allocates 20 thousand buffers of random size from 16 bytes to
\ 16k bytes.  to make sure the operating system actually gives us the 
\ allocated pages each allocated buffer is erased.  when all buffers 
\ have been allocated they are freed in a random order.

\ during allocation and deallocation various information is displayed.  
\ the top number is the total number of buffers thus far allocated. 
\ we then break down each heap.  we show the size of the largest block, 
\ the total free memory, the total memory allocted and the number of 
\ buffers allocated within the heap.

\ you will see your swap useage go up dramatically as blocks are allocated 
\ and then back down as they are freed. 

\ this code might run into ulimit for some users and might not function 
\ in a sane manner - ill add a call to sys-getrlimit to memoryl.f
\ eventually

\ ------------------------------------------------------------------------

 40000 var ###              \ number of buffers to allocate

create buffers ### 4* allot \ array of allocated buffer addresses
buffers ### 4* erase

\ ------------------------------------------------------------------------

0 var a-failed              \ number of failed allocations
0 var f-failed              \ number of failed de-allocations

\ ------------------------------------------------------------------------
\ allocate all buffers

: ab
  2 0 at ." Allocating " ### . ." buffers...   "
  ### 0
  do
    4 0 at i 1+ 10 .r
    16384 rnd 1+
    15 + -16 and dup
    allocate
    if 
      dup buffers i 4* + !
      swap erase 
      5 0 at .mem-info el
      key? if key quit then
    else
      incr> a-failed
      drop
    then
  loop ;

\ ------------------------------------------------------------------------
\ free all buffers

: fb
  2 0 at ." De-Allocating " ### . ." buffers...   "
  ### 0
  do
    4 0 at ### i - 1+ 10 .r
    buffers i 4* +
    dup @ free not
    if
      incr> f-failed
      drop
    else 
      off
    then
    5 0 at .mem-info el
    key? if key quit then
  loop ;

\ ------------------------------------------------------------------------
\ randomize allocated blocks array

: shuffle
  ### 0 
  do
    begin
      ### rnd 4* 
      ### rnd 4* 2dup =
    while
      2drop
    repeat
    buffers + swap buffers +
    2dup @ swap @
    rot ! swap !
  loop ;
    
\ ------------------------------------------------------------------------

: burn
  rand clear curoff
  timer-reset
  ab shuffle fb 
  cr cr .elapsed
  curon cr ;

\ ------------------------------------------------------------------------

 burn

\ ========================================================================


