\ color.f       - isforth console colour handling stuff
\ ------------------------------------------------------------------------

 .( loading color.f ) cr

\ ------------------------------------------------------------------------

 terminal definitions

\ ------------------------------------------------------------------------
\ colours   (yes guys, there really is a letter 'u' in there)

 0 const black
 1 const red
 2 const green
 3 const yellow
 4 const blue
 5 const magenta            \ i would call this pink myself (eterm)
 6 const cyan
 7 const white

\ ------------------------------------------------------------------------

 0 var fg                   \ current foreground colour
 0 var bg                   \ current background colour
 0 var attrib
 0 var pref                 \ bitflags indicating bold, underline etc

\ ------------------------------------------------------------------------
\ set new foreground or background colors

<headers

: (>fg)         ( n1 --- )
  dup attrib $f0 and        \ mask out old fg from attrib variable
  + !> attrib               \ change fg and set variable
  !> fg ;                   \ remember current fg attrib

\ ------------------------------------------------------------------------
\ set new foreground or background colors

headers>

: >fg           ( n1 --- )
  dup (>fg) setaf ;

\ ------------------------------------------------------------------------

<headers

: (>bg)         ( n1 --- ) 
  dup 4 <<                  \ shift attrib into position
  attrib $0f and            \ mask out old bg
  + !> attrib               \ reset 
  !> bg ;                   \ remember current bg attrib   

\ ------------------------------------------------------------------------

headers>

: >bg           ( n1 --- ) 
  dup (>bg) setab ;   

\ ------------------------------------------------------------------------
\ set both fg and bg 

: >attrib       ( n1 --- )
  dup 
  $f and >fg
  4 >> >bg ;

\ ------------------------------------------------------------------------
\ turn various attributes on and off

\ the terminfo for some terminals doesnt list an sgr format string even
\ though the terminals themselves support one.  (rxvt types only show 
\ the sgr0 format string - eterm, linux terminal have both sgr and sgr0)
\
\ some of these attributes have two associated escape sequences.  one to
\ turn the attribute on, the other to turn it off.  someone in their 
\ infinite moronic stupidity neglected to include a format string to turn 
\ bold off. the only way to turn bold off reliably over all terminal types 
\ is to turn off 'all' attributes by iusing an sgr0 and to then 
\ re-establish the ones you realy didnt want to lose.
\
\ the book termcap and terminfo rationalizes this somewhat but its a 
\ complete CROCK OF SHIT!  terminfo is BRAINDEAD here and the people who 
\ put together incomplete terminfo file are ALSO braindead!!!!!

<headers

: (>pref)
  sgr0                      \ clear all attribs
  pref 
  dup 1 and ?: smso noop    \ set standout mode ?
  dup 2 and ?: smul noop    \ set underline mode ?
  dup 4 and ?: rev  noop    \ set reverse video ?
      8 and ?: bold noop ;  \ set bold ?

\ ------------------------------------------------------------------------

\ the above sgr0 very kindly resets the forground and background colours 
\ to their defaults.  nice of the terminal to force me into changing them
\ back again, specially when changing attributes is one of the slowest 
\ things you can do in a terminal

headers>

: >pref
  (>pref)
  fg >fg bg >bg ;           \ restore the damned colors
 
\ ------------------------------------------------------------------------
\ set a given preference bit flag

<headers

: prefset       ( n1 --- ) 
  dup pref and
  if
    drop exit
  then
  pref or !> pref 
  >pref ;

\ ------------------------------------------------------------------------
\ clear a given preference bit flag

: prefclr       ( n1 --- ) 
  dup pref and
  if
    not pref and !> pref 
    >pref exit
  then
  drop exit ;

\ ------------------------------------------------------------------------

headers>

: >so       ( --- ) 1 prefset ;
: <so       ( --- ) 1 prefclr ;
: >ul       ( --- ) 2 prefset ;
: <ul       ( --- ) 2 prefclr ;
: >rev      ( --- ) 4 prefset ;
: <rev      ( --- ) 4 prefclr ;
: >bold     ( --- ) 8 prefset ;
: <bold     ( --- ) 8 prefclr ;

\ ------------------------------------------------------------------------

: >norm off> pref >pref ;   \ does not reset colors (no thanx to terminfo)

\ ------------------------------------------------------------------------

 forth definitions

\ ========================================================================
