\ t-keys.f      - isforth terminfo keyboard handling
\ ------------------------------------------------------------------------

 .( loading t-keys.f ) cr

\ ------------------------------------------------------------------------

 terminal definitions

\ ------------------------------------------------------------------------

headers>

  0 const key-bs         1 const key-del         2 const key-down  
  3 const key-f1         4 const key-f10         5 const key-f2     
  6 const key-f3         7 const key-f4          8 const key-f5
  9 const key-f6        10 const key-f7         11 const key-f8   
 12 const key-f9        13 const key-home       14 const key-insert 
 15 const key-left      16 const key-pdown      17 const key-pup   
 18 const key-right     19 const key-up         20 const key-btab 
 21 const key-end       22 const key-enter      23 const key-sdel
 24 const key-send      25 const key-shome      26 const key-sleft 
 27 const key-spdn      28 const key-spup       29 const key-sright 
 30 const key-f11       31 const key-f12        32 const key-mouse

<headers

\ ------------------------------------------------------------------------
\ key sequences

<headers

110 0 format (kbs)          \ key backspace
\ 112 ktbc                  \ clear all tabs key
\ 114 kclr                  \ clear screen key
\ 116 kctab                 \ clear tab key
118 0 format (kdch1)        \ delete character key
\ 120 kdl1                  \ delete line key
122 0 format (kcud1)        \ cursor down key
\ 124 krmir                 \ sent by rmir or smir in insert mode
\ 126 kel                 * \ clear eol key
\ 128 ked                   \ clear end of screen key
\ 130 kf0                   \ f0 key
132 0 format (kf1)          \ f1 key
134 0 format (kf10)         \ f10 key
136 0 format (kf2)          \ f2 key
138 0 format (kf3)          \ f3 key
140 0 format (kf4)          \ f4 key
142 0 format (kf5)          \ f5 key
144 0 format (kf6)          \ f6 key
146 0 format (kf7)          \ f7 key
148 0 format (kf8)          \ f8 key
150 0 format (kf9)          \ f9 key
152 0 format (khome)        \ home key
154 0 format (kich1)        \ insert character key
\ 156 kil1                  \ insert line key
158 0 format (kcub1)        \ cursor left key
\ 160 kll                   \ lower left key
162 0 format (knp)          \ next page key
164 0 format (kpp)          \ previous page key
166 0 format (kcuf1)        \ cursor right key
\ 168 kind                  \ scroll forward key
\ 170 kri                   \ scroll backwards key
\ 172 khts                  \ set tab key
174 0 format (kcuu1)        \ cursor up key
\ 176 rmks                  \ leave keyboard transmit mode
\ 178 smks                  \ enter keyboard transmit mode
\ 278 ka1                 * \ upper left of keypad
\ 280 ka3                 * \ upper right of keypad
\ 282 kb2                 * \ center of keypad
\ 284 kc1                 * \ lower left of keypad
\ 286 kc3                 * \ lower right of keypad
296 0 format (kcbt)         \ backtab key
\ 316 kbeg                * \ begin key
\ 318 kcan                  \ cansel key
\ 320 kclo                  \ close key
\ 322 kcmd                  \ key command
\ 324 kcpy                  \ key copy
\ 326 kcrt                  \ key create
328 0 format (kend)         \ key end
330 0 format (kent)         \ key enter
\ 332 kext                  \ key exit
\ 334 kfnd                * \ key find
\ 336 khlp                * \ key help
\ 338 kmrk                  \ key mark
\ 340 kmsg                  \ key message
\ 342 kmov                  \ key move
\ 344 knxt                  \ key next
\ 346 kopn                  \ key open
\ 348 kopt                  \ options key
\ 350 kprv                  \ previous key
\ 352 kprt                  \ print key
\ 354 krdo                  \ redo key
\ 356 kref                  \ reference key
\ 358 krfr                  \ refresh key
\ 360 krpl                  \ replace key
\ 362 krst                  \ restart key
\ 364 kres                  \ resume key
\ 366 ksav                  \ save key
\ 368 kspd                  \ suspend key
\ 370 kund                  \ undo key
\ 372 kBEG                  \ shifted begin key
\ 374 kCAN                  \ shifted cansel key
\ 376 kCMD                  \ shifted command key
\ 378 kCPY                  \ shifted copy key
\ 380 kCRT                  \ shifted create key
382 0 format (kDC)          \ shifted delete character key
\ 384 kDL                   \ shifted delete line key
\ 386 kslt                * \ select key
388 0 format (kEND)         \ shifted end key
\ 390 kEOL                  \ shifted clear to end of line key
\ 392 kEXT                  \ shifted exit key
\ 394 kFND                  \ shifted find key
\ 396 kHLP                  \ shifted help key
398 0 format (kHOM)         \ shifted home key
\ 400 kIC                   \ shifted insert character key
402 0 format (kLFT)         \ shifted cursor left
\ 404 kMSG                  \ shifted message key
\ 406 kMOV                  \ shifted move key
408 0 format (kNXT)         \ shifted next key
\ 410 kOPT                  \ shifted options key
412 0 format (kPRV)         \ shifted previous key
\ 414 kPRT                  \ shifted print key
\ 416 kRDO                  \ shifted redo key
\ 418 kRPL                  \ shifted replace key
420 0 format (kRIT)         \ shifted cursor right
\ 422 kRES                  \ shifted resume key
\ 424 kSAV                  \ shifted save key
\ 426 kSPD                  \ shifted suspend key
\ 428 kUND                  \ shifted undo key
432 0 format (kf11)         \ f11 function key
434 0 format (kf12)         \ f12 function key
\ 436 kf13                * \ f13 function key
\ 438 kf14                * \ f14 function key
\ 440 kf15                * \ f15 function key
\ 442 kf16                * \ f16 function key
\ 444 kf17                * \ f17 function key
\ 446 kf18                * \ f18 function key
\ 448 kf19                * \ f19 function key
\ 450 kf20                * \ f20 function key
\ 452 kf21                  \ f21 function key
\ 454 kf22                  \ f22 function key
\ 456 kf23                  \ f23 function key
\ 458 kf24                  \ f24 function key
\ 460 kf25                  \ f25 function key
\ 462 kf26                  \ f26 function key
\ 464 kf27                  \ f27 function key
\ 466 kf28                  \ f28 function key
\ 468 kf29                  \ f29 function key
\ 470 kf30                  \ f30 function key
\ 472 kf31                  \ f31 function key
\ 474 kf32                  \ f32 function key
\ 476 kf33                  \ f33 function key
\ 478 kf34                  \ f34 function key
\ 480 kf35                  \ f35 function key
\ 482 kf36                  \ f36 function key
\ 484 kf37                  \ f37 function key
\ 486 kf38                  \ f38 function key
\ 488 kf39                  \ f39 function key
\ 490 kf40                  \ f40 function key
\ 492 kf41                  \ f41 function key
\ 494 kf42                  \ f42 function key
\ 496 kf43                  \ f43 function key
\ 498 kf44                  \ f44 function key
\ 500 kf45                  \ f45 function key
\ 502 kf46                  \ f46 function key
\ 504 kf47                  \ f47 function key
\ 506 kf48                  \ f48 function key
\ 508 kf49                  \ f49 function key
\ 510 kf50                  \ f50 function key
\ 512 kf51                  \ f51 function key
\ 514 kf52                  \ f52 function key
\ 516 kf53                  \ f53 function key
\ 518 kf54                  \ f54 function key
\ 520 kf55                  \ f55 function key
\ 522 kf56                  \ f56 function key
\ 524 kf57                  \ f57 function key
\ 526 kf58                  \ f58 function key
\ 528 kf59                  \ f59 function key
\ 530 kf60                  \ f60 function key
\ 532 kf61                  \ f61 function key
\ 534 kf62                  \ f62 function key
\ 536 kf63                  \ f64 function key
710 0 format (kmous)        \ mouse event has occurred

\ ------------------------------------------------------------------------
\ get address of key sequences n1
 
: k-table       ( n1 --- )
  exec:
    (kbs)  (kdch1) (kcud1) (kf1)   (kf10) (kf2)   (kf3)   (kf4) 
    (kf5)  (kf6)   (kf7)   (kf8)   (kf9)  (khome) (kich1) (kcub1) 
    (knp)  (kpp)   (kcuf1) (kcuu1) (kcbt) (kend)  (kent)  (kDC)
    (kEND) (kHOM)  (kLFT)  (kNXT)  (kPRV) (kRIT)  (kf11)  (kf12) 
    (kmous) ;

\ ------------------------------------------------------------------------
\ try match keybuff with strings from key-words in k-table

\ too much if/and/but loop nesting

: match-key         ( --- n1 true | false )
  33 0                      \ k-table has 33 entries
  do
    off> #$buffer           \ empty $buffer
    i k-table               \ execute next k-table entry
    keybuff c@              \ is the revieved key escape sequence
    #$buffer =              \ the same length as the one now in $buffer
    if
      $buffer keybuff count \ yes - compare them
      comp
      if                    \ match ?
        i 1+ undo exit      \ yes - clean up and return match number
      then
    then
  loop 
  false ;                   \ no match found

\ ------------------------------------------------------------------------
\ actions for each key sequence

: key-actions       ( key --- )
  exec:
    noop noop noop noop noop noop noop noop
    noop noop noop noop noop noop noop noop
    noop noop noop noop noop noop noop noop
    noop noop noop noop noop noop noop noop
    noop ;

\ ------------------------------------------------------------------------
\ set action for specified key

headers>

: key-action        ( action key --- old-action )
  1+ 4* 
  [ ' key-actions >body ] literal
  + dup @ >r ! r> ;

\ ------------------------------------------------------------------------
\ see if string a1 matches strings from any of the words in above table

<headers

: (newkey)          ( false --- f1 )
  match-key ?dup            \ is key a known key sequence?
  if
    1- key-actions          \ yes - zero base the key and do action
    exit
  then
  drop true ;               \ no - force exit from loop in newkey below

\ ------------------------------------------------------------------------
\ action for enter key

headers>

: do-enter          ( false --- true )
  drop true                 \ forces exit from loop within next word
  $0a01 keybuff w! ;        \ put a single lf in keybuff

' do-enter key-enter key-action

\ ------------------------------------------------------------------------

: newkey        ( --- c1 )
  begin
    false
    read-keys               \ read keys into key buffer
    (newkey)                \ interpret key sequence
  until 
  keybuff 1+                \ return the single key
  c@ exit ;

\ ------------------------------------------------------------------------
\ not sure what these are exactly

\ 180 lf0                   \ label on key f0
\ 182 lf1                   \ label on key f1
\ 184 lf10                  \ label on key f10
\ 186 lf2                   \ label on key f2
\ 188 lf3                   \ label on key f3
\ 190 lf4                   \ label on key f4
\ 192 lf5                   \ label on key f5
\ 194 lf6                   \ label on key f6
\ 196 lf7                   \ label on key f7
\ 198 lf8                   \ label on key f8
\ 200 lf9                   \ label on key f9

\ ------------------------------------------------------------------------

 forth definitions

\ ========================================================================
