\ tui.f         - isforth text user interface structures and temp vars
\ ------------------------------------------------------------------------

.( loading tui.f ) cr

\ ------------------------------------------------------------------------

 terminal definitions forth

\ ------------------------------------------------------------------------
\ temp store for various window/scren structure elements

\ way too many temp store variables but they simplify the issue alot

<headers

 0 var sw                   \ screen width
 0 var sh                   \ screen height
 0 var sb1                  \ screen buffer 1 = new state
 0 var sb2                  \ screen buffer 2 = old state

 0 var wx                   \ window xco in associated screen
 0 var wy                   \ window yco in associated screen
 0 var ww                   \ window width
 0 var wh                   \ window height
 0 var wb                   \ window buffer address

 0 var font                 \ flag - is console using ibm box charset
 0 var attrib               \ current fg/bg colours

headers>

\ ------------------------------------------------------------------------

struct: scr
  1 dfield s.link           \ link to previous screen
  1 dfield s.buffer1        \ new state of screen
  1 dfield s.buffer2        \ old state of screen
  1 dfield s.window         \ first window of in screen
  1 wfield s.width          \ width of screen
  1 wfield s.height         \ height of screen
  1 wfield s.flags          \ not defined yet
;struct

\ ------------------------------------------------------------------------
\ the window structure

struct: win
  1 dfield w.next           \ next window in chain
  1 dfield w.buffer         \ window buffer address
  1 dfield w.screen         \ which screen this window is associated with
  1 dfield w.menu           \ address of menu structure for window
  1 wfield w.flags          \ see below
  1 wfield w.xco            \ window x coordinate on screen
  1 wfield w.yco            \ window y coordinate on screen
  1 wfield w.width          \ width of window
  1 wfield w.height         \ height of window
  1 wfield w.cx             \ cursor x within window
  1 wfield w.cy             \ cursor y within window
  1 bfield w.colors         \ foreground and background colours
  1 bfield w.attrs          \ font, bold, underline etc
  1 bfield w.blank          \ normally a space
;struct

\ ------------------------------------------------------------------------

\ w.flags
\
\ bit 0    window is boxed
\ bit 1-7  reserved

\ ------------------------------------------------------------------------
\ damned forward references - this one is needed though

 defer .window

\ ------------------------------------------------------------------------
\ load component parts of text user interface

\ having load files inside a load file is bad but as long as you dont
\ go overboard (e.g. c) your fine

 fload src/terminal/tui/screen.f
 fload src/terminal/tui/window.f
 fload src/terminal/tui/menu.f

\ ------------------------------------------------------------------------

 behead forth definitions

\ ========================================================================
