\ z-keys.f      - isforth multi terminal key sequence handler
\ ------------------------------------------------------------------------

 .( loading z-keys.f ) cr

\ ------------------------------------------------------------------------

 terminal definitions
 
\ ------------------------------------------------------------------------

\ this code treates the following keys as function keys 

\ Insert  = f13
\ Delete  = f14
\ Home    = f15
\ End     = f16
\ P Up    = f17
\ P Dn    = f18
\ Up      = f19
\ Down    = f20
\ Left    = f21
\ Right   = f22
\ tab     = f23     \ only if shifted

<headers

\ ------------------------------------------------------------------------

 0 var cntrl
 0 var shift
 0 var alt
 0 var f-key
 0 var char

\ ------------------------------------------------------------------------
\ is char c1 a single key character common to all terminals ?

: test0          ( c1 --- c1 f1 )
  dup $09 = >r              \ tab ?
  dup $0a = >r              \ lf ?
  dup $1b = >r              \ escape ?
  dup $20 $7f between
  r> | 2r> | | ;
 
\ ------------------------------------------------------------------------
\ cntrl characters common to all terminals

create table1
 $01 c, $02 c, $03 c, $04 c, $05 c, $06 c, $07 c, $08 c, 
 $0b c, $0c c, $0e c, $0f c, $10 c, $12 c, $14 c, $15 c, 
 $16 c, $17 c, $18 c, $19 c, $1a c, $1c c, $1d c, $1e c, 
 $1f c, 

create table2
 'a' c, 'b' c, 'c' c, 'd' c, 'e' c, 'f' c, 'g' c, 'h' c,
 'k' c, 'l' c, 'n' c, 'o' c, 'p' c, 'r' c, 't' c, 'u' c,
 'v' c, 'w' c, 'x' c, 'y' c, 'z' c, '4' c, ']' c, '6' c,
 '7' c,

\ ------------------------------------------------------------------------
\ is c1 is a control character common to all terminals

: test1     ( c1 --- c1 f1 )
  table1 25 pluck           \ is char c1 in table 1 ?
  scan nip dup
  if
    on> cntrl               \ its a control char alright
    [ table2 25 + ] literal \ get which char it is from table 2
    swap - c@ nip
    true
  then ;

\ ------------------------------------------------------------------------
\ alt keys specific to xterm
 
create table3
 $9b c, $e0 c, $ad c, $bd c, $ff c, $89 c, $f1 c, $f7 c,
 $e5 c, $f2 c, $f4 c, $f9 c, $f5 c, $e9 c, $ef c, $f0 c,
 $db c, $dd c, $dc c, $e1 c, $f3 c, $e4 c, $e6 c, $e7 c,
 $e8 c, $ea c, $eb c, $ec c, $bb c, $a7 c, $8d c, $fa c,
 $f8 c, $e3 c, $f6 c, $e2 c, $ee c, $ed c, $ac c, $ae c,
 $af c, $a0 c,

\ ------------------------------------------------------------------------
\ is char c1 an alt keypress from xterm ?

: test2     ( c1 --- c1 f1 )
  table3 42 pluck scan nip
  if  
    $80 - true
  else
    false
  then ;

\ ------------------------------------------------------------------------
\ linux term function key sequences

create table4
 6 c,
 4 c, $1b c, $5b c, $5b c, $41 c,     1 c,
 4 c, $1b c, $5b c, $5b c, $42 c,     2 c,
 4 c, $1b c, $5b c, $5b c, $43 c,     3 c,
 4 c, $1b c, $5b c, $5b c, $44 c,     4 c,
 4 c, $1b c, $5b c, $5b c, $45 c,     5 c,
 4 c, $1b c, $5b c, $34 c, $7e c,    16 c,

\ ------------------------------------------------------------------------
\ function key sequences common to eterm and rxvt

create table5
 4 c,
 5 c, $1b c, $5b c, $31 c, $31 c, $7e c,     1 c,
 5 c, $1b c, $5b c, $31 c, $32 c, $7e c,     2 c,
 5 c, $1b c, $5b c, $31 c, $33 c, $7e c,     3 c,
 5 c, $1b c, $5b c, $31 c, $34 c, $7e c,     4 c,

\ ------------------------------------------------------------------------
\ function keys specific to xterm

create table6
 6 c,
 3 c, $1b c, $4f c, $50 c,       1 c,
 3 c, $1b c, $4f c, $51 c,       2 c,
 3 c, $1b c, $4f c, $52 c,       3 c,
 3 c, $1b c, $4f c, $53 c,       4 c,
 3 c, $1b c, $5b c, $48 c,      15 c,
 3 c, $1b c, $5b c, $46 c,      16 c,

\ ------------------------------------------------------------------------
\ function key sequences common to all terminals.

create table7
 18 c,
 5 c, $1b c, $5b c, $31 c, $35 c, $7e c,    05 c,
 5 c, $1b c, $5b c, $31 c, $37 c, $7e c,    06 c,
 5 c, $1b c, $5b c, $31 c, $38 c, $7e c,    07 c,
 5 c, $1b c, $5b c, $31 c, $39 c, $7e c,    08 c,
 5 c, $1b c, $5b c, $32 c, $30 c, $7e c,    09 c,
 5 c, $1b c, $5b c, $32 c, $31 c, $7e c,    10 c,
 5 c, $1b c, $5b c, $32 c, $33 c, $7e c,    11 c,
 5 c, $1b c, $5b c, $32 c, $34 c, $7e c,    12 c,
 4 c, $1b c, $5b c, $32 c, $7e c,           13 c,
 4 c, $1b c, $5b c, $33 c, $7e c,           14 c,
 4 c, $1b c, $5b c, $31 c, $7e c,           15 c,
 4 c, $1b c, $5b c, $38 c, $7e c,           16 c,
 4 c, $1b c, $5b c, $35 c, $7e c,           17 c,
 4 c, $1b c, $5b c, $36 c, $7e c,           18 c,
 3 c, $1b c, $5b c, $41 c,                  19 c,
 3 c, $1b c, $5b c, $42 c,                  20 c,
 3 c, $1b c, $5b c, $43 c,                  21 c,
 3 c, $1b c, $5b c, $44 c,                  22 c,

\ ------------------------------------------------------------------------
\ shifted function key sequences returned by linux eterm and rxvt

create table8
 10 c,
 5 c, $1b c, $5b c, $32 c, $33 c, $7e c,        1 c,
 5 c, $1b c, $5b c, $32 c, $34 c, $7e c,        2 c,
 5 c, $1b c, $5b c, $32 c, $35 c, $7e c,        3 c,
 5 c, $1b c, $5b c, $32 c, $36 c, $7e c,        4 c,
 5 c, $1b c, $5b c, $32 c, $38 c, $7e c,        5 c,
 5 c, $1b c, $5b c, $32 c, $39 c, $7e c,        6 c,
 5 c, $1b c, $5b c, $33 c, $31 c, $7e c,        7 c,
 5 c, $1b c, $5b c, $33 c, $32 c, $7e c,        8 c,
 5 c, $1b c, $5b c, $33 c, $33 c, $7e c,        9 c,
 5 c, $1b c, $5b c, $33 c, $34 c, $7e c,       10 c,

\ ------------------------------------------------------------------------
\ shifted function keys retuned bu linux

create table9
 10 c,
 5 c, $1b c, $5b c, $32 c, $33 c, $7e c,        11 c,
 5 c, $1b c, $5b c, $32 c, $34 c, $7e c,        12 c,
 4 c, $1b c, $5b c, $32 c, $7e c,               13 c,
 4 c, $1b c, $5b c, $33 c, $7e c,               14 c,
 4 c, $1b c, $5b c, $31 c, $7e c,               15 c,
 4 c, $1b c, $5b c, $34 c, $7e c,               16 c,
 3 c, $1b c, $5b c, $41 c,                      19 c,
 3 c, $1b c, $5b c, $42 c,                      20 c,
 3 c, $1b c, $5b c, $43 c,                      22 c,
 3 c, $1b c, $5b c, $44 c,                      21 c,

\ ------------------------------------------------------------------------
\ shifted function keys returned by xterm

create table10
 20 c,
 4 c, $1b c, $4f c, $32 c, $50 c,                            1 c, 
 4 c, $1b c, $4f c, $32 c, $51 c,                            2 c,
 4 c, $1b c, $4f c, $32 c, $52 c,                            3 c,
 4 c, $1b c, $4f c, $32 c, $53 c,                            4 c,
 7 c, $1b c, $5b c, $31 c, $35 c, $3b c, $32 c, $7e c,       5 c,
 7 c, $1b c, $5b c, $31 c, $37 c, $3b c, $32 c, $7e c,       6 c,
 7 c, $1b c, $5b c, $31 c, $38 c, $3b c, $32 c, $7e c,       7 c,
 7 c, $1b c, $5b c, $31 c, $39 c, $3b c, $32 c, $73 c,       8 c,
 7 c, $1b c, $5b c, $32 c, $30 c, $3b c, $32 c, $7e c,       9 c,
 7 c, $1b c, $5b c, $32 c, $31 c, $3b c, $32 c, $7e c,      10 c,
 7 c, $1b c, $5b c, $32 c, $33 c, $3b c, $32 c, $7e c,      11 c,
 7 c, $1b c, $5b c, $32 c, $34 c, $3b c, $32 c, $7e c,      12 c,
 6 c, $1b c, $5b c, $33 c, $3b c, $32 c, $7e c,             14 c,
 4 c, $1b c, $5b c, $32 c, $48 c,                           15 c,
 4 c, $1b c, $5b c, $32 c, $46 c,                           16 c,
 3 c, $1b c, $5b c, $5a c,                                  23 c,
 4 c, $1b c, $5b c, $32 c, $41 c,                           19 c,
 4 c, $1b c, $5b c, $32 c, $42 c,                           20 c,
 4 c, $1b c, $5b c, $32 c, $43 c,                           22 c,
 4 c, $1b c, $5b c, $32 c, $44 c,                           21 c,
  
\ ------------------------------------------------------------------------
\ shifted function keys returned by eterm and rxvt

create table11
 10 c,
 5 c, $1b c, $5b c, $32 c, $33 c, $24 c,         11 c,
 5 c, $1b c, $5b c, $32 c, $34 c, $24 c,         12 c,
 4 c, $1b c, $5b c, $33 c, $24 c,                14 c,
 4 c, $1b c, $5b c, $37 c, $24 c,                15 c,
 4 c, $1b c, $5b c, $38 c, $24 c,                16 c,
 3 c, $1b c, $5b c, $5a c,                       23 c,
 3 c, $1b c, $5b c, $61 c,                       19 c,
 3 c, $1b c, $5b c, $62 c,                       20 c,
 3 c, $1b c, $5b c, $64 c,                       21 c,
 3 c, $1b c, $5b c, $63 c,                       22 c,

\ ------------------------------------------------------------------------
\ control sequences specific to linux

create table12
 22 c,
 4 c, $1b c, $5b c, $5b c, $41 c,           1 c,
 4 c, $1b c, $5b c, $5b c, $42 c,           2 c,
 4 c, $1b c, $5b c, $5b c, $43 c,           3 c,
 4 c, $1b c, $5b c, $5b c, $44 c,           4 c,
 4 c, $1b c, $5b c, $5b c, $45 c,           5 c,
 5 c, $1b c, $5b c, $31 c, $37 c, $7e c,    6 c,
 5 c, $1b c, $5b c, $31 c, $38 c, $7e c,    7 c,
 5 c, $1b c, $5b c, $31 c, $39 c, $7e c,    8 c,
 5 c, $1b c, $5b c, $32 c, $30 c, $7e c,    9 c,
 5 c, $1b c, $5b c, $32 c, $31 c, $7e c,   10 c,
 5 c, $1b c, $5b c, $32 c, $33 c, $7e c,   11 c,
 5 c, $1b c, $5b c, $32 c, $34 c, $7e c,   12 c,
 4 c, $1b c, $5b c, $32 c, $7e c,          13 c,
 4 c, $1b c, $5b c, $33 c, $7e c,          14 c,
 4 c, $1b c, $5b c, $31 c, $7e c,          15 c,
 4 c, $1b c, $5b c, $34 c, $7e c,          16 c,
 4 c, $1b c, $5b c, $35 c, $7e c,          17 c,
 4 c, $1b c, $5b c, $36 c, $7e c,          18 c,
 3 c, $1b c, $5b c, $41 c,                 19 c,
 3 c, $1b c, $5b c, $42 c,                 20 c,
 3 c, $1b c, $5b c, $44 c,                 21 c,
 3 c, $1b c, $5b c, $43 c,                 22 c,

\ ------------------------------------------------------------------------
\ control sequences specific to xterm

create table13
 22 c,
 4 c, $1b c, $4f c, $35 c, $50 c,                         1 c,
 4 c, $1b c, $4f c, $35 c, $51 c,                         2 c,
 4 c, $1b c, $4f c, $35 c, $52 c,                         3 c,
 4 c, $1b c, $4f c, $35 c, $53 c,                         4 c,
 7 c, $1b c, $5b c, $31 c, $35 c, $3b c, $35 c, $7e c,    5 c,
 7 c, $1b c, $5b c, $31 c, $35 c, $3b c, $35 c, $7e c,    6 c,
 7 c, $1b c, $5b c, $31 c, $38 c, $3b c, $35 c, $7e c,    7 c,
 7 c, $1b c, $5b c, $31 c, $39 c, $3b c, $35 c, $7e c,    8 c,
 7 c, $1b c, $5b c, $32 c, $30 c, $3b c, $35 c, $7e c,    9 c,
 7 c, $1b c, $5b c, $32 c, $31 c, $3b c, $35 c, $7e c,   10 c,
 7 c, $1b c, $5b c, $32 c, $33 c, $3b c, $35 c, $7e c,   11 c,
 7 c, $1b c, $5b c, $32 c, $34 c, $3b c, $35 c, $7e c,   12 c,
 6 c, $1b c, $5b c, $32 c, $3b c, $35 c, $7e c,          13 c,
 6 c, $1b c, $5b c, $33 c, $3b c, $35 c, $7e c,          14 c, 
 4 c, $1b c, $5b c, $35 c, $48 c,                        15 c,
 4 c, $1b c, $5b c, $35 c, $46 c,                        16 c,
 6 c, $1b c, $5b c, $35 c, $3b c, $35 c, $7e c,          17 c,
 6 c, $1b c, $5b c, $36 c, $3b c, $35 c, $7e c,          18 c,
 4 c, $1b c, $5b c, $35 c, $41 c,                        19 c,
 4 c, $1b c, $5b c, $35 c, $42 c,                        20 c,
 4 c, $1b c, $5b c, $35 c, $44 c,                        21 c,
 4 c, $1b c, $5b c, $35 c, $43 c,                        22 c,

\ ------------------------------------------------------------------------
\ control sequences common to eterm and rxvt

create table14
 22 c,
 5 c, $1b c, $5b c, $31 c, $31 c, $5e c,         1 c,
 5 c, $1b c, $5b c, $31 c, $32 c, $5e c,         2 c,
 5 c, $1b c, $5b c, $31 c, $33 c, $5e c,         3 c,
 5 c, $1b c, $5b c, $31 c, $34 c, $5e c,         4 c,
 5 c, $1b c, $5b c, $31 c, $35 c, $5e c,         5 c,
 5 c, $1b c, $5b c, $31 c, $37 c, $5e c,         6 c,
 5 c, $1b c, $5b c, $31 c, $38 c, $5e c,         7 c,
 5 c, $1b c, $5b c, $31 c, $39 c, $5e c,         8 c,
 5 c, $1b c, $5b c, $32 c, $30 c, $5e c,         9 c,
 5 c, $1b c, $5b c, $32 c, $31 c, $5e c,        10 c,
 5 c, $1b c, $5b c, $32 c, $33 c, $5e c,        11 c,
 5 c, $1b c, $5b c, $32 c, $34 c, $5e c,        12 c,
 4 c, $1b c, $5b c, $32 c, $5e c,               13 c,
 4 c, $1b c, $5b c, $33 c, $5e c,               14 c,
 4 c, $1b c, $5b c, $37 c, $5e c,               15 c,
 4 c, $1b c, $5b c, $38 c, $5e c,               16 c,
 4 c, $1b c, $5b c, $35 c, $5e c,               17 c,
 4 c, $1b c, $5b c, $36 c, $5e c,               18 c,
 3 c, $1b c, $4f c, $61 c,                      19 c,
 3 c, $1b c, $4f c, $62 c,                      20 c,
 3 c, $1b c, $4f c, $64 c,                      21 c,
 3 c, $1b c, $4f c, $63 c,                      22 c,

\ ------------------------------------------------------------------------
\ alt key sequences common to linux, eterm and rxvt

\ these arent function keys

create table15
 41 c,
 2 c, $1b c, $1b c,
 2 c, $1b c, $2d c,
 2 c, $1b c, $3d c,
 2 c, $1b c, $7f c,
 2 c, $1b c, $09 c,
 2 c, $1b c, $71 c,
 2 c, $1b c, $77 c,
 2 c, $1b c, $65 c,
 2 c, $1b c, $72 c,
 2 c, $1b c, $74 c,
 2 c, $1b c, $79 c,
 2 c, $1b c, $75 c,
 2 c, $1b c, $69 c,
 2 c, $1b c, $6f c,
 2 c, $1b c, $70 c,
 2 c, $1b c, $5b c,
 2 c, $1b c, $5d c,
 2 c, $1b c, $5c c,
 2 c, $1b c, $61 c,
 2 c, $1b c, $73 c,
 2 c, $1b c, $64 c,
 2 c, $1b c, $66 c,
 2 c, $1b c, $67 c,
 2 c, $1b c, $68 c,
 2 c, $1b c, $6a c,
 2 c, $1b c, $6b c,
 2 c, $1b c, $6c c,
 2 c, $1b c, $3b c,
 2 c, $1b c, $27 c,
 2 c, $1b c, $0a c,
 2 c, $1b c, $7a c,
 2 c, $1b c, $78 c,
 2 c, $1b c, $63 c,
 2 c, $1b c, $76 c,
 2 c, $1b c, $62 c,
 2 c, $1b c, $6e c,
 2 c, $1b c, $6d c,
 2 c, $1b c, $2c c,
 2 c, $1b c, $2e c,
 2 c, $1b c, $2f c,
 2 c, $1b c, $20 c,

\ ------------------------------------------------------------------------
\ search table for a key sequence 

: (test3)       ( table --- a1 f1 )
  count                     \ get number of sequences in this table
  for
    dup c@                  \ get lenght of next sequence
    keybuff c@ =            \ same length as key sequence?
    if
      dup count             \ yes - compare them
      keybuff 1+ 
      swap comp
      if                    \ same ?
        r>drop              \ yes - undo loop
        true exit           \ exit success
      then
    then
    count + 1+              \ no match - scan to next sequence in list
  nxt
  drop
  false ;

\ ------------------------------------------------------------------------

: test3     ( --- )
  table15 (test3)
  if
    1+ c@ true
  else
    drop false
  then ;

\ ------------------------------------------------------------------------
\ alt function keys specific to linux

create table16
 8 c,
 4 c, $1b c, $5b c, $32 c, $7e c,       13 c,
 4 c, $1b c, $5b c, $33 c, $7e c,       14 c, 
 4 c, $1b c, $5b c, $31 c, $7e c,       15 c,
 4 c, $1b c, $5b c, $34 c, $7e c,       16 c,
 4 c, $1b c, $5b c, $35 c, $7e c,       17 c,
 4 c, $1b c, $5b c, $36 c, $7e c,       18 c,
 3 c, $1b c, $5b c, $41 c,              19 c,
 3 c, $1b c, $5b c, $42 c,              20 c,

\ ------------------------------------------------------------------------
\ alt function keys common to eterm and rxvt

create table17
 22 c,
 6 c, $1b c, $1b c, $5b c, $31 c, $31 c, $7e c,         1 c,
 6 c, $1b c, $1b c, $5b c, $31 c, $32 c, $7e c,         2 c,
 6 c, $1b c, $1b c, $5b c, $31 c, $31 c, $7e c,         3 c,
 6 c, $1b c, $1b c, $5b c, $31 c, $34 c, $7e c,         4 c,
 6 c, $1b c, $1b c, $5b c, $31 c, $35 c, $7e c,         5 c,
 6 c, $1b c, $1b c, $5b c, $31 c, $37 c, $7e c,         6 c,
 6 c, $1b c, $1b c, $5b c, $31 c, $38 c, $7e c,         7 c,
 6 c, $1b c, $1b c, $5b c, $31 c, $39 c, $7e c,         8 c,
 6 c, $1b c, $1b c, $5b c, $32 c, $30 c, $7e c,         9 c,
 6 c, $1b c, $1b c, $5b c, $32 c, $31 c, $7e c,        10 c,
 6 c, $1b c, $1b c, $5b c, $32 c, $33 c, $7e c,        11 c,
 6 c, $1b c, $1b c, $5b c, $32 c, $34 c, $7e c,        12 c,
 5 c, $1b c, $1b c, $5b c, $32 c, $7e c,               13 c,
 5 c, $1b c, $1b c, $5b c, $33 c, $7e c,               14 c,
 5 c, $1b c, $1b c, $5b c, $37 c, $7e c,               15 c,
 5 c, $1b c, $1b c, $5b c, $38 c, $7e c,               16 c,
 5 c, $1b c, $1b c, $5b c, $35 c, $7e c,               17 c,
 5 c, $1b c, $1b c, $5b c, $36 c, $7e c,               18 c,
 4 c, $1b c, $1b c, $5b c, $41 c,                      19 c,
 4 c, $1b c, $1b c, $5b c, $42 c,                      20 c,
 4 c, $1b c, $1b c, $5b c, $44 c,                      21 c,
 4 c, $1b c, $1b c, $5b c, $43 c,                      22 c,

\ ------------------------------------------------------------------------
\ alt function keys specific to xterm

create table18
 22 c,
 4 c, $1b c, $4f c, $33 c, $50 c,                             1 c,
 4 c, $1b c, $4f c, $33 c, $51 c,                             2 c,
 4 c, $1b c, $4f c, $33 c, $52 c,                             3 c,
 4 c, $1b c, $4f c, $33 c, $53 c,                             4 c,
 4 c, $1b c, $4f c, $33 c, $53 c,                             5 c,
 7 c, $1b c, $5b c, $31 c, $37 c, $3b c, $33 c, $7e c,        6 c,
 7 c, $1b c, $5b c, $31 c, $38 c, $3b c, $33 c, $7e c,        7 c,
 7 c, $1b c, $5b c, $31 c, $39 c, $3b c, $33 c, $7e c,        8 c,
 7 c, $1b c, $5b c, $32 c, $30 c, $3b c, $33 c, $7e c,        9 c,
 7 c, $1b c, $5b c, $32 c, $31 c, $3b c, $33 c, $7e c,       10 c,
 7 c, $1b c, $5b c, $32 c, $33 c, $3b c, $33 c, $7e c,       11 c,
 7 c, $1b c, $5b c, $32 c, $34 c, $3b c, $33 c, $7e c,       12 c,
 6 c, $1b c, $5b c, $32 c, $3b c, $33 c, $7e c,              13 c,
 6 c, $1b c, $5b c, $33 c, $3b c, $33 c, $7e c,              14 c,
 4 c, $1b c, $5b c, $33 c, $48 c,                            15 c,
 4 c, $1b c, $5b c, $33 c, $46 c,                            16 c,
 6 c, $1b c, $5b c, $35 c, $3b c, $33 c, $7e c,              17 c,
 6 c, $1b c, $3b c, $36 c, $3b c, $33 c, $7e c,              18 c,
 4 c, $1b c, $5b c, $33 c, $41 c,                            19 c,
 4 c, $1b c, $5b c, $33 c, $42 c,                            20 c,
 4 c, $1b c, $5b c, $33 c, $44 c,                            21 c,
 4 c, $1b c, $5b c, $33 c, $43 c,                            22 c,

\ ------------------------------------------------------------------------
\ search list of tables for key sequence

: test4     ( list --- f1 )
  begin
    dup @ dup
  while
    (test3) 
    if
      count + c@            \ get function key that was pressed
      !> f-key
      true exit
    then
    4+
  repeat
  nip ;

\ ------------------------------------------------------------------------
\ lists of function key tables for each terminal

create l-tables
  table4 , table7 , 0 ,         \ no shift or alt or cntrl
  table8  , table9  , 0 ,       \ shifted
  table12 , 0 ,                 \ control
  table16 , 0 ,       \ alt

create e-tables
  table5 , table7 , 0 ,
  table8  , table11 , 0 ,
  table14 , 0 ,
  table17 , 0 ,

create x-tables
  table6 , table7 , 0 ,
  table10 , 0 ,
  table13 , 0 ,
  table18 , 0 ,

create r-tables
  table5 , table7 , 0 ,
  table8  , table11 , 0 ,
  table14 , 0 ,
  table17 , 0 ,

  headers>

\ ------------------------------------------------------------------------

 forth definitions

\ ========================================================================
